#define __KERNEL__
#define MODULE

#include <linux/errno.h>
#include <linux/fs.h>
#include <linux/module.h>
#include <linux/ioport.h>
#include <linux/ioctl.h>
#include <asm/io.h>
#include <asm/segment.h>
#include <asm/uaccess.h>

#include "arm.h"

static unsigned int busy = 0;
int dat;
int data;

/*ǥХե뤬openȸƤФؿ*/
static int arm_open(struct inode *inode, struct file *filp){
  if (busy) return - EBUSY;
  
  printk("arm_open:\n");
  printk("   filp->f_version     : %lu \n",filp->f_version);

  linecount = LINECOUNT;
  printk("   LINECOUNT: %d \n",linecount);

  busy = 1;
  MOD_INC_USE_COUNT;

  arm_detect(ARM_PORT_READ,ARM_PORT_MASK);

  return 0;
}
/*
static ssize_t arm_read(struct file *file,char *buf,size_t count,loff_t *offset){
  
  char *str;
  int len = LEN;
  str = it;

  if(linecount == 0){
    return 0;
  }else{
    linecount--;
    }

  data = inw(ARM_PORT_READ);
  data = data & 0x0003;
  if(data == 0x0001){
    str[0] = 1;
    str[1] = 0;printk("data = %c\n",*str);
  }
  else if(data == 0x0002){
    str[0] = 1;
    str[1] = 0;printk("data = %c",*str);
  }
  else if(data == 0x0003){
    str[0] = 1;
    str[1] = 1;printk("data = %c",*str);
  }
	else{
	  str[0] = 0;
	  str[1] = 0;
	}
  copy_to_user(buf,str,len);
  printk("arm_read.\n");
  
  return len;

  }*/

/*ǥХɥ饤Ф̿᤬Ϥ줿Ȥ˸ƤФؿ*/
static ssize_t arm_write(/*struct inode *inode,*/ struct file *file, unsigned int cmd, unsigned long arg){
   int setcode =16;
  int a;
  printk("arm_write:\n");

  printk("%d\n",cmd);

  switch(cmd){
    /*    #ifdef ARM_DEBUG
        case ARM_HARDRESET:
	   mod_use_count_ = 1;
	   #endif*/

  case ARM_ON:
	printk("   ARM_GO :\n");
	outw(1,ARM_PORT_MASK);
        a=inw(ARM_PORT_MASK);
	printk("%d\n",a);

	break;

  case ARM_OFF:
	printk("   ARM_BACK :\n");
	outw(2,ARM_PORT_MASK);
	a=inw(ARM_PORT_MASK);
	  printk("%d\n",a);
          
	break;

	/* case ARM_STOP:
	printk("  ARM_STOP:\n");
	outw(3,ARM_PORT_READ);
	a=inw(ARM_PORT_READ);
	printk("%d\n",a);        
 
	break;
	*/
     default:
       printk("default\n");
	return -EINVAL;
  }
  printk("arm_write\n");
  return 0;
}

/*ǥХե뤬closeȸƤФؿ*/
static int arm_release(struct inode *inode, struct file *filp){
  busy = 0;
  MOD_DEC_USE_COUNT;

  printk("arm_close:\n");
  printk("   filp->f_version     : %lu \n",filp->f_version);

  arm_module_release(ARM_PORT_READ,ARM_PORT_MASK);

  return 0;
}

/*ǥХեȤƤӽФؿϿ뤿ι¤*/
static struct file_operations arm_fops = {
   owner:              THIS_MODULE,
   read:               NULL,
   write:              arm_write, 
   ioctl:              NULL,
   open:               arm_open,
   release:            arm_release,
 };


static int arm_detect(unsigned int port, unsigned int range){
  int err;

  printk("arm_detect:\n");

  if ((err=check_region(port,range)) < 0 ){
    printk("   This ports <%x - %x> are using now!\n",port,range);
    printk("   check_region(port,range) : %d\n",err);
  } 
  
  request_region(port,range,"arm");     /* always success */

  printk("   I/Oport from: %x   to: %x \n",port,range);

  return 0;
}




static void arm_module_release(unsigned int port,unsigned int range){
  release_region(port,range);
  printk("arm_module_release:\n");
  printk("   I/Oport from: %x   to: %x \n",port,range);
}


int init_module (void){
  int i;

  printk("install 'arm' into major %d\n",ARM_MAJOR);
  i = register_chrdev (ARM_MAJOR, "arm", &arm_fops);

  if (i){
     printk("device registration error\n");
     return -EBUSY;
  }

  return 0;
} 


void cleanup_module (void){
  int i;

  printk("remove 'arm' from major %d\n",ARM_MAJOR);
  i = unregister_chrdev (ARM_MAJOR,"arm");

  if (i){
     printk ("unregister_chrdev failed\n");
  }

}
